({
// local representation of all CSS3 named colors, companion to dojo.colors.  To be used where descriptive information
// is required for each color, such as a palette widget, and not for specifying color programatically.

//Note: due to the SVG 1.0 spec additions, some of these are alternate spellings for the same color e.g. gray vs. gray. 
//TODO: should we be using unique rgb values as keys instead and avoid these duplicates, or rely on the caller to do the reverse mapping?
aliceblue: "alice blue",
antiquewhite: "antique white",
aqua: "aqua",
aquamarine: "aquamarine",
azure: "תכלת עז",
beige: "בז'",
bisque: "bisque",
black: "שחור",
blanchedalmond: "blanched almond",
blue: "כחול",
blueviolet: "כחול-סגול",
brown: "חום",
burlywood: "burlywood",
cadetblue: "כחול ים",
chartreuse: "chartreuse",
chocolate: "שוקולד",
coral: "אלמוג",
cornflowerblue: "cornflower blue",
cornsilk: "cornsilk",
crimson: "ארגמן ",
cyan: "טורקיז",
darkblue: "כחול כהה",
darkcyan: "טורקיז כהה",
darkgoldenrod: "dark goldenrod",
darkgray: "אפור כהה",
darkgreen: "ירוק כהה",
darkgrey: "אפור כהה", // same as darkgray
darkkhaki: "חאקי כהה  ",
darkmagenta: "בורדו כהה",
darkolivegreen: "ירוק זית כהה",
darkorange: "כתום כהה",
darkorchid: "dark orchid",
darkred: "אדום כהה",
darksalmon: "סלמון כהה",
darkseagreen: "ירוק ים כהה",
darkslateblue: "כחול צפחה כהה",
darkslategray: "אפור צפחה כהה",
darkslategrey: "אפור צפחה כהה", // same as darkslategray
darkturquoise: "טורקיז כהה",
darkviolet: "סגול כהה",
deeppink: "ורוד עמוק",
deepskyblue: "כחול שמיים עמוק",
dimgray: "אפור עמום",
dimgrey: "אפור עמום", // same as dimgray
dodgerblue: "כחול",
firebrick: "fire brick",
floralwhite: "floral white",
forestgreen: "ירוק יער",
fuchsia: "ורוד בהיר",
gainsboro: "gainsboro",
ghostwhite: "ghost white",
gold: "זהב",
goldenrod: "goldenrod",
gray: "אפור",
green: "ירוק",
greenyellow: "ירוק-צהוב",
grey: "אפור", // same as gray
honeydew: "honeydew",
hotpink: "ורוד לוהט",
indianred: "indian red",
indigo: "אינדיגו",
ivory: "שנהב",
khaki: "חאקי ",
lavender: "לבנדר ",
lavenderblush: "סומק לבנדר",
lawngreen: "ירוק דשא",
lemonchiffon: "lemon chiffon",
lightblue: "תכלת",
lightcoral: "אלמוג בהיר",
lightcyan: "טורקיז בהיר",
lightgoldenrodyellow: "light goldenrod yellow",
lightgray: "אפור בהיר",
lightgreen: "ירוק בהיר",
lightgrey: "אפור בהיר", // same as lightgray
lightpink: "ורוד בהיר  ",
lightsalmon: "סלמון בהיר",
lightseagreen: "ירוק ים בהיר",
lightskyblue: "כחול שמיים בהיר",
lightslategray: "אפור צפחה בהיר",
lightslategrey: "אפור צפחה בהיר", // same as lightslategray
lightsteelblue: "כחול פלדה בהיר",
lightyellow: "צהוב בהיר",
lime: "לימון",
limegreen: "ירוק לימוני",
linen: "linen",
magenta: "בורדו ",
maroon: "חום אדמדם",
mediumaquamarine: "medium aquamarine",
mediumblue: "medium blue",
mediumorchid: "medium orchid",
mediumpurple: "medium purple",
mediumseagreen: "medium sea green",
mediumslateblue: "medium slate blue",
mediumspringgreen: "medium spring green",
mediumturquoise: "medium turquoise",
mediumvioletred: "medium violet-red",
midnightblue: "midnight blue",
mintcream: "mint cream",
mistyrose: "misty rose",
moccasin: "moccasin",
navajowhite: "navajo white",
navy: "navy",
oldlace: "old lace",
olive: "olive",
olivedrab: "זית עמום ",
orange: "כתום ",
orangered: "כתום אדום ",
orchid: "סחלב ",
palegoldenrod: "pale goldenrod",
palegreen: "pale green",
paleturquoise: "pale turquoise",
palevioletred: "pale violet-red",
papayawhip: "papaya whip",
peachpuff: "peach puff",
peru: "peru",
pink: "pink",
plum: "שזיף ",
powderblue: "כחול חיוור",
purple: "סגול ",
red: "אדום",
rosybrown: "חום ורדרד ",
royalblue: "כחול מלכותי",
saddlebrown: "חום דהוי",
salmon: "סלמון ",
sandybrown: "חום חולי ",
seagreen: "ירוק ים",
seashell: "צדף ",
sienna: "sienna",
silver: "כסף",
skyblue: "כחול שמיים ",
slateblue: "כחול צפחה",
slategray: "אפור צפחה",
slategrey: "אפור צפחה", // same as slategray
snow: "שלג",
springgreen: "ירוק אביב",
steelblue: "כחול פלדה",
tan: "חום אדמדם",
teal: "כחול-ירוק כהה",
thistle: "דרדר",
tomato: "עגבניה",
turquoise: "טורקיז ",
violet: "סגול ",
wheat: "חיוט",
white: "לבן ",
whitesmoke: "עשן לבן ",
yellow: "צהוב ",
yellowgreen: "ירוק צהוב"
})
